function [Field,Dx,Dy]=Volume_density_fast_2D(GG,FX,FY,rho,k,N,flag1)
    FT_source=fftn(rho,[2*N,2*N]);
    if flag1==0
        Field=ifftn(FT_source.*GG);
        Field=Field(1:N,1:N);
        Dx=0;
        Dy=0;
    elseif flag1==1
        Field=0;
        Dx=ifftn(i*2*pi*FX.*FT_source.*GG);
        Dy=ifftn(i*2*pi*FY.*FT_source.*GG);
        Dx=Dx(1:N,1:N);
        Dy=Dy(1:N,1:N);
    elseif flag1==2
        Field=ifftn(FT_source.*GG);
        Dx=ifftn(i*2*pi*FX.*FT_source.*GG);
        Dy=ifftn(i*2*pi*FY.*FT_source.*GG);
        Field=Field(1:N,1:N);
        Dx=Dx(1:N,1:N);
        Dy=Dy(1:N,1:N);
    end
end

