function U=campo_Lejano(Diag,k,N,M,x0,y0,R_max)
    Cn_norm=coef_diag(Diag);
    Cn=normaliza_coef(Cn_norm,M);

    phi_targ=linspace(-pi,pi,2*M+1);
    phi_targ=phi_targ(1:end-1);
    X=R_max*cos(phi_targ)+.5;
    Y=R_max*sin(phi_targ)+.5;
    
    
    R=sqrt((X-x0).^2+(Y-y0).^2);
    PHI=atan2((Y-y0),(X-x0));
    U=X*0;
    for count=-M:M-1
        U=U+Cn(count+M+1)*besselh(count,k*R).*exp(-i*count*PHI);
    end
%    plot(PHI,abs(U))
%    stop
    Umbral=10; %%Este umbral puede que haya que modificarlo (para no deslumbrarse en el pcolor y para no tocar la lente)
    indices= abs(U)>Umbral;
    U(indices)=1;
%    surf(X,Y,abs(U))
%    shading interp
end
