function hCampLen= compFrecs(N,kVar,diagLog,phiVector,F_tot,rho)
%% Anlisis de frecuencia de la lente de Fresnel
    maxDiagTot= zeros(1,length(kVar));
    legcomp= cell(zeros(1,length(kVar)));
    sum= 0;
    hCampLen=gobjects(2*length(kVar),1);
    
    for countcF= 1:length(kVar)
        datTit=kVar(countcF);
        [hCampLen,sum]= dibujaLente(N,datTit,F_tot(:,:,countcF),...
            rho(:,:,countcF),sum,hCampLen);
        maxDiagC= max(diagLog(countcF,:));
        maxDiagTot(countcF)= maxDiagC;

        legnd= ['k= ' num2str(kVar(countcF))...
            ' Max= ' num2str(maxDiagC)];%Aade leyenda de cada frecuencia
        hold on
        legcomp(countcF)= cellstr(legnd);%Array con todas las leyendas
        
    end

    sum=sum+1;
    hCampLen(sum)= figure;
    plot(phiVector,diagLog)
    title('Diagramas de radiacin a diferentes frecuencias')
    legend(legcomp)
    xlabel('\phi (rad)', 'FontSize',12,'FontWeight','bold')
    ylabel('Directividad (dB)', 'FontSize',12,'FontWeight','bold')
    xlim([-3.5 3.5])
    Diagax = gca;
    Diagax.FontSize= 12;
    Diagax.FontWeight='bold';
    hold off
    
    sum=sum+1;
    hCampLen(sum)= figure;
    plot(kVar,maxDiagTot,'-*','LineWidth',0.7)
    xlim([kVar(1)-1 kVar(end)+1])
    xlabel('k','FontSize',12,'FontWeight','bold')
    ylabel('Directividad mxima (dB)','FontSize',12,'FontWeight','bold')        
    DmaxAx = gca;
    DmaxAx.FontSize= 12;
    DmaxAx.FontWeight='bold';
    
end