function diagLog=diagrama_2D_v4(rho,N,M,k,x0,y0,Diag_foco,R_max)
    size(Diag_foco);
    Diag_foco=interpft(Diag_foco,2*M); %Interpolacin por facor 2*M
    size(Diag_foco);
    x=linspace(0,1,N+1);
    x=x(1:end-1);
    y=x;
    dx=x(2)-x(1);
    dy=dx;
    phi_vector=linspace(-pi,pi,2*M+1);
    phi_vector=phi_vector(1:end-1);
    [X,Y]=meshgrid(x,y);

    
    phi_targ=linspace(-pi,pi,2*M+1);
    phi_targ=phi_targ(1:end-1);
    x_targ_vect=R_max*cos(phi_targ)+.5;
    y_targ_vect=R_max*sin(phi_targ)+.5;
    U_far=zeros(1,2*M);
    for count=1:2*M
        x_targ=x_targ_vect(count);
        y_targ=y_targ_vect(count);
        R=sqrt((X-x_targ).^2+(Y-y_targ).^2);
        integrando=i/4*besselh(0,k*R).*rho;
        U_far(count)=sum(sum(integrando))*dx*dy;
    end

    U_foco_far=campo_Lejano(Diag_foco,k,N,M,x0,y0,R_max);
    U_far_tot=U_far+U_foco_far;
%{
    polar(phi_vector,abs(U_far_tot))
    hold on
    polar(phi_vector,abs(U_foco_far),'r')
    hold off
    title('Diagrama de radiacin polar')

    figure
    semilogy(phi_vector,2*abs(U_far_tot))
    hold on
    semilogy(phi_vector,2*abs(U_foco_far),'r')
    hold off
%     figure
%     plot(phi_vector,20*log10(abs(U_foco_far)),'g')
    %}
    dphi=phi_targ(2)-phi_targ(1);
    W_rad=sum(abs(U_far_tot).^2)*dphi*R_max;
    
    Diagrama_tot=abs(U_far_tot).^2./(W_rad/(2*pi*R_max));
    diagLog=10*log10(Diagrama_tot);
%     figure
%     plot(phi_vector,10*log10(Diagrama_tot),'r')
%     title('Diagrama de radiacin cartesiano')
%     legend(num2str(max(10*log10(Diagrama_tot))))

   
end