function prueba_fourier_coef(M)
%     x=linspace(-pi,pi,2*M+1);
%     x=x(1:end-1);
%     dx=x(2)-x(1);
%     y=exp(-10*x.^2);
%     plot(x,y)
%     figure
%     polar(x,y)
% %    figure
% %    F=mi_fft(y,dx)
% %    plot(x,real(F))
%     
%     Cn=mis_coef(y);
%     y_reconst=y*0;
%     
%     phi=linspace(-pi,pi,2*M+1);
%     phi=phi(1:end-1);
%     
%     for count=-M:M-1
%        y_reconst=y_reconst+Cn(count+M+1)*exp(-i*count*phi);
%     end
%     figure
%     plot(phi,real(y_reconst))
%     figure
%     polar(phi,real(y_reconst))
%     plot(phi,abs(y-y_reconst))
    x0=-.2;
    y0=.5;
    k=2*pi*10;
    N=400;
    Diag=diagrama_foco(M);
    U=campo_cercano(Diag,k,N,M,x0,y0);
    
end



function F=mi_fft(y,dx)
    F=fftshift(fft(ifftshift(y)))*dx;
end

function F=mi_ifft(y,dx)
    F=fftshift(ifft(ifftshift(y)))/(dx);
end


function Diag=diagrama_foco(M)
  %Obtiene un muestreo del diagrama con 2M puntos entre -pi y pi
   phi=linspace(-pi,pi,2*M+1);
   phi=phi(1:end-1);
   Diag=exp(-10*(phi-pi/8).^2);
end

function Cn=coef_diag(Diag)
    %Obtengo 2M coeficientes del diagrama, desde el C(-M) hasta el C(M-1)
    Cn=fftshift(ifft(ifftshift(Diag)));
end

function Cn_out=normaliza_coef(Cn,M)
    n_vect=(-M:M-1);
    Cn_out=Cn.*exp(i*n_vect*pi/2);
end

function U=campo_cercano(Diag,k,N,M,x0,y0)
    Cn_norm=coef_diag(Diag);
    Cn=normaliza_coef(Cn_norm,M);
    x=linspace(0,1,N+1);
    x=x(1:end-1);
    y=x;
    [X,Y]=meshgrid(x,y);
    R=sqrt((X-x0).^2+(Y-y0).^2);
    PHI=atan2((Y-y0),(X-x0));
%    R=100000;
%    PHI=linspace(-pi,pi,2*M+1);
%    PHI=PHI(1:end-1);
    U=X*0;
    for count=-M:M-1
        U=U+Cn(count+M+1)*besselh(count,k*R).*exp(-i*count*PHI);
    end
%    plot(PHI,abs(U))
%    stop
    Umbral=10; %%Este umbral puede que haya que modificarlo (para no deslumbrarse en el pcolor y para no tocar la lente)
    indices=find(abs(U)>Umbral);
    U(indices)=1;
    surf(X,Y,abs(U))
    shading interp
end

function Diag=diagrama_2D_v3(rho,N,M,k,x0,y0,Diag_foco)
    x=linspace(0,1,N+1);
    x=x(1:end-1);
    y=x;
    dx=x(2)-x(1);
    dy=dx;
    phi_vector=linspace(-pi,pi,M+1);
    phi_vector=phi_vector(1:end-1);
    [X,Y]=meshgrid(x,y);
    Diag=phi_vector*0;
    for count=1:M
        phi=phi_vector(count);
        integrando=exp(-i*k*(cos(phi)*X+sin(phi)*Y)).*rho;
        Diag(count)=sum(sum(integrando))*dx*dy+integrando_2;
    end
    
    Diag_total=Diag+4/i*Diag_foco*exp(-i*k*(cos(phi)*x0+sin(phi)*y0));
%    polar(phi_vector,abs(Diag))
end
