function [B,U]=RHS_Helmholtz_2D(N,k,q)

     sigma_s=.05;
     h=.05;     

    x=linspace(0,1,N+1);
    x=x(1:end-1);
    x(end/2);
    y=x;
    z=x;
    x0=.5;
    y0=.35123456;

    [X,Y]=meshgrid(x,y);
    r=sqrt((X-x0).^2+(Y-y0).^2);
    ind_aux=find(r==0);
%    r(ind_aux)=0.00000001;
    a=2*sigma_s^2;
%      R=sqrt(h*exp(-r.^2/a)+r.^2);
%     U=besselh(0,k*R);
% %      B1=2*R;
% %      B2=4*R.^3;
% %      B3=8*R.^2;
% %      B4=2*r.*R;
% %      A1=k*(4*h*r.^2.*exp(-r.^2/a)/a^2-2*h*exp(-r.^2/a)/a+2).*besselh(0,k*R);
% %      A2=k*(2*r-2*h*r.*exp(-r.^2/a)/a).^2.*besselh(1,k*R);
% %      A3=k^2*(2*r-2*h*r.*exp(-r.^2/a)/a).^2.*(besselh(0,k*R)-besselh(2,k*R));
% %      A4=k*(2*r-2*h*r.*exp(-r.^2/a)/a).*besselh(1,k*R);
% %      Lapl_2D=-(A1)./(B1)+(A2)./(B2)-(A3)./(B3)-(A4)./(B4);
%      Lapl_2D=(k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*(((2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*besselj(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(2.*(h.*exp(-r.^2./a) + r.^2)) - (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*besselj(0, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2))))./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2)) - ((k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*besselj(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2)) + (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*bessely(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)).*i)./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./r + (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*(((2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*bessely(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(2.*(h.*exp(-r.^2./a) + r.^2)) - (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).*bessely(0, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2))).*i)./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2)) + (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).^2.*besselj(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)))./(4.*(h.*exp(-r.^2./a) + r.^2).^(3./2)) + (k.*(2.*r - (2.*h.*r.*exp(-r.^2./a))./a).^2.*bessely(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)).*i)./(4.*(h.*exp(-r.^2./a) + r.^2).^(3./2)) - (k.*besselj(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)).*((4.*h.*r.^2.*exp(-r.^2./a))./a.^2 - (2.*h.*exp(-r.^2./a))./a + 2))./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2)) - (k.*bessely(1, k.*(h.*exp(-r.^2./a) + r.^2).^(1./2)).*((4.*h.*r.^2.*exp(-r.^2./a))./a.^2 - (2.*h.*exp(-r.^2./a))./a + 2).*i)./(2.*(h.*exp(-r.^2./a) + r.^2).^(1./2));
%     
%      RHS=Lapl_2D+k^2*(1+q).*U;
% %    Lapl(ind_aux);
% %    U(ind_aux);
% %    d2_Lapl(ind_aux)./r(ind_aux)
%      B=[RHS(:)];
%      U=U(:);
%     find(isnan(B)==1)
%     R=r(:);
%     find((r)==0)
%     r(555)
%     'dentro'
%     pause



%%%% PLANE WAVE
   angulo=5/180*pi;
   U=exp(i*k*(cos(angulo)*X+sin(angulo)*Y));
   
   %U=exp(i*k*X);
   RHS=-k^2*q.*U;    
   B=[RHS(:)];
   U=U(:);

%%%%  COMPLEX SOURCE POINT
%   U=Complex_source_point_beam(k,N,-0.01,.77,0,.5);
%   RHS=-k^2*q.*U;    
%   B=[RHS(:)];
%   U=U(:);
% 
    
end